package cn.iocoder.yudao.module.pms.service.yanfan.category;

import cn.iocoder.yudao.framework.common.exception.ErrorCode;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.common.util.object.BeanUtils;
import cn.iocoder.yudao.module.pms.controller.admin.yanfan.category.vo.IotYfCategoryPageReqVO;
import cn.iocoder.yudao.module.pms.controller.admin.yanfan.category.vo.IotYfCategorySaveReqVO;
import cn.iocoder.yudao.module.pms.dal.dataobject.yanfan.category.IotYfCategoryDO;
import cn.iocoder.yudao.module.pms.dal.mysql.yanfan.category.IotYfCategoryMapper;
import org.springframework.stereotype.Service;
import org.springframework.validation.annotation.Validated;

import javax.annotation.Resource;

import static cn.iocoder.yudao.framework.common.exception.util.ServiceExceptionUtil.exception;

/**
 * yf产品分类 Service 实现类
 *
 * @author 超级管理员
 */
@Service
@Validated
public class IotCategoryServiceImpl implements IotCategoryService {

    @Resource
    private IotYfCategoryMapper iotYfCategoryMapper;

    @Override
    public Long createIotCategory(IotYfCategorySaveReqVO createReqVO) {
        // 插入
        IotYfCategoryDO iotCategory = BeanUtils.toBean(createReqVO, IotYfCategoryDO.class);
        iotCategory.setIsSys(true);
        iotCategory.setDeleted(false);
        iotYfCategoryMapper.insert(iotCategory);
        // 返回
        return iotCategory.getCategoryId();
    }

    @Override
    public void updateIotCategory(IotYfCategorySaveReqVO updateReqVO) {
        // 校验存在
        validateIotCategoryExists(updateReqVO.getCategoryId());
        // 更新
        IotYfCategoryDO updateObj = BeanUtils.toBean(updateReqVO, IotYfCategoryDO.class);
        iotYfCategoryMapper.updateById(updateObj);
    }

    @Override
    public void deleteIotCategory(Long id) {
        // 校验存在
        validateIotCategoryExists(id);
        // 删除
        iotYfCategoryMapper.deleteById(id);
    }

    private void validateIotCategoryExists(Long id) {
        if (iotYfCategoryMapper.selectById(id) == null) {
            throw exception(new ErrorCode(222,"产品分类不存在"));
        }
    }

    @Override
    public IotYfCategoryDO getIotCategory(Long id) {
        return iotYfCategoryMapper.selectById(id);
    }

    @Override
    public PageResult<IotYfCategoryDO> getIotCategoryPage(IotYfCategoryPageReqVO pageReqVO) {
        return iotYfCategoryMapper.selectPage(pageReqVO);
    }

}
